"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Content = void 0;

var _react = _interopRequireDefault(require("react"));

var _clsx = _interopRequireDefault(require("clsx"));

var _styles = require("@mui/material/styles");

var _Root = require("../Root/Root");

var _getContentSxProps = require("./getContentSxProps");

var _constant = require("../utils/constant");

var _FullscreenContext = require("../Fullscreen/FullscreenContext");

var _excluded = ["children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ContentRoot = (0, _styles.styled)("main", {
  name: "AppContent",
  slot: "Root",
  overridesResolver: function overridesResolver(props, styles) {
    return styles.root;
  }
})(function (_ref) {
  var ownerState = _ref.ownerState;
  return _objectSpread({
    transition: _constant.CSS_TRANSITION
  }, ownerState.isFullscreen && {
    flexGrow: 1,
    minHeight: "0px",
    display: "flex"
  });
});

var Content = function Content(_ref2) {
  var children = _ref2.children,
      inProps = _objectWithoutProperties(_ref2, _excluded);

  var props = (0, _styles.useThemeProps)({
    props: inProps,
    name: "AppContent"
  });
  var ctx = (0, _Root.useLayoutCtx)();
  var builder = ctx.builder;
  var sxProps = (0, _getContentSxProps.getContentSxProps)(builder, _constant.CONTENT_ID);
  var isFullscreen = (0, _FullscreenContext.useFullscreenCtx)();
  return /*#__PURE__*/_react["default"].createElement(ContentRoot, _extends({}, props, {
    className: (0, _clsx["default"])("Content", props.className),
    sx: _objectSpread(_objectSpread(_objectSpread({}, isFullscreen && {
      flexGrow: 1,
      minHeight: 0,
      display: "flex"
    }), props.sx), sxProps),
    ownerState: {
      isFullscreen: isFullscreen
    }
  }), typeof children === "function" ? children(ctx) : children);
};

exports.Content = Content;