"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EdgeTrigger = void 0;

var _react = _interopRequireDefault(require("react"));

var _styles = require("@mui/material/styles");

var _useEdgeSidebar2 = require("./useEdgeSidebar");

var _excluded = ["target", "display", "children"],
    _excluded2 = ["sidebarId", "edgeSidebar"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var EdgeTriggerRoot = (0, _styles.styled)("div", {
  name: "EdgeTrigger"
})({});

var EdgeTrigger = function EdgeTrigger(_ref) {
  var _state$field;

  var target = _ref.target,
      _ref$display = _ref.display,
      display = _ref$display === void 0 ? "inline-flex" : _ref$display,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, _excluded);

  var anchor = target.anchor,
      field = target.field;

  var _useEdgeSidebar = (0, _useEdgeSidebar2.useEdgeSidebar)({
    anchor: anchor
  }),
      sidebarId = _useEdgeSidebar.sidebarId,
      edgeSidebar = _useEdgeSidebar.edgeSidebar,
      state = _objectWithoutProperties(_useEdgeSidebar, _excluded2);

  var sxDisplay = edgeSidebar === null || edgeSidebar === void 0 ? void 0 : edgeSidebar.getEdgeTriggerSxDisplay({
    display: display,
    field: field
  });

  var setState = function setState(val) {};

  if (field === "collapsed") {
    setState = function setState(val) {
      return state.setCollapsed(sidebarId, val);
    };
  }

  if (field === "open") {
    setState = function setState(val) {
      return state.setOpen(sidebarId, val);
    };
  }

  return /*#__PURE__*/_react["default"].createElement(EdgeTriggerRoot, _extends({}, props, {
    sx: _objectSpread({
      display: sxDisplay
    }, props.sx)
  }), typeof children === "function" && children((_state$field = state[field]) !== null && _state$field !== void 0 ? _state$field : false, setState));
};

exports.EdgeTrigger = EdgeTrigger;