"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useEdgeSidebar = void 0;

var _Root = require("../Root/Root");

var _EdgeSidebar = require("./EdgeSidebar");

var _excluded = ["state", "builder"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useEdgeSidebar = function useEdgeSidebar(options) {
  var _sidebar$anchor;

  var _ref = options !== null && options !== void 0 ? options : {},
      anchor = _ref.anchor;

  var sidebar = (0, _EdgeSidebar.useLooseSidebarCtx)();

  var _useLayoutCtx = (0, _Root.useLayoutCtx)(),
      state = _useLayoutCtx.state,
      builder = _useLayoutCtx.builder,
      triggers = _objectWithoutProperties(_useLayoutCtx, _excluded);

  if (!sidebar && !anchor) {
    throw new Error('Missing "anchor" property because this component is rendered outside of <EdgeSidebar />');
  }

  var sidebarAnchor = (_sidebar$anchor = sidebar === null || sidebar === void 0 ? void 0 : sidebar.anchor) !== null && _sidebar$anchor !== void 0 ? _sidebar$anchor : anchor;
  var sidebarId = sidebar ? sidebar.id : "".concat(sidebarAnchor, "EdgeSidebar");
  var sidebarState = state[sidebarId];
  return _objectSpread(_objectSpread(_objectSpread({
    sidebarId: sidebarId
  }, sidebarState), triggers), {}, {
    edgeSidebar: builder[sidebarId]
  });
};

exports.useEdgeSidebar = useEdgeSidebar;