import React from "react";
import { EdgeSidebarBuilder, EdgeSidebarSetupParams } from "../EdgeSidebar/EdgeSidebarBuilder";
import { HeaderBuilder, HeaderSetupParams } from "../Header/HeaderBuilder";
import { InsetSetupParams, InsetSidebarBuilder } from "../InsetSidebar/InsetSidebarBuilder";
import { EDGE_SIDEBAR_ID } from "../utils/constant";
declare type SidebarState = {
    collapsed?: boolean;
    open?: boolean;
};
declare type State = {
    leftEdgeSidebar?: SidebarState;
    rightEdgeSidebar?: SidebarState;
};
declare type Builder = {
    header?: HeaderBuilder;
    topHeader?: HeaderBuilder;
    subheader?: HeaderBuilder;
    leftEdgeSidebar?: EdgeSidebarBuilder;
    rightEdgeSidebar?: EdgeSidebarBuilder;
    leftInsetSidebar?: InsetSidebarBuilder;
    rightInsetSidebar?: InsetSidebarBuilder;
};
export declare type ContextValue = {
    state: State;
    builder: Builder;
    setOpen: (id: EDGE_SIDEBAR_ID, value: boolean) => void;
    toggleLeftSidebarOpen: () => void;
    toggleLeftSidebarCollapsed: () => void;
    setCollapsed: (id: EDGE_SIDEBAR_ID, value: boolean) => void;
    toggleRightSidebarOpen: () => void;
    toggleRightSidebarCollapsed: () => void;
};
export declare type PropsWithFunctionChildren<Props = any, Params = ContextValue> = Omit<Props, "children"> & {
    children?: React.ReactNode | ((ctx: Params) => React.ReactNode);
};
export declare const useLayoutCtx: () => ContextValue;
export declare const LayoutConsumer: React.Consumer<ContextValue | undefined>;
export declare type Scheme = {
    header?: HeaderSetupParams;
    topHeader?: HeaderSetupParams;
    subheader?: HeaderSetupParams;
    leftEdgeSidebar?: EdgeSidebarSetupParams;
    rightEdgeSidebar?: EdgeSidebarSetupParams;
    leftInsetSidebar?: InsetSetupParams;
    rightInsetSidebar?: InsetSetupParams;
};
export declare type RootProps = {
    initialState?: State;
    scheme: Scheme;
};
export declare const Root: ({ initialState: controlledInitialState, scheme, children, }: PropsWithFunctionChildren<RootProps>) => JSX.Element;
export {};
