import { useScreen } from "./useScreen";
import { useLayoutCtx } from "../Root/Root";
import { useScrollY } from "./useScrollY";
import { pickNearestBreakpoint } from "../utils/pickNearestBreakpoint";
import { HeadersCompiler } from "../MultiHeaders/HeadersCompiler"; // todo write test

export var useInsetHeaderMagnet = disabled => {
  // this hook will run only for <InsetSidebar position="fixed" />
  var {
    builder
  } = useLayoutCtx();
  var screen = useScreen(); // dont't calculate scrollY if not magnet for performance

  var scrollY = useScrollY(disabled);
  if (disabled) return {
    marginTop: ""
  };
  var offset = HeadersCompiler([builder.header, builder.topHeader, builder.subheader]).getAllHeight().diffHeight;
  var maxOffset = offset && screen ? pickNearestBreakpoint(offset, screen) : 0;
  return {
    marginTop: "max(-".concat(scrollY !== null && scrollY !== void 0 ? scrollY : 0, "px, calc(-1 * ").concat(maxOffset, "))")
  }; // inline style
};