"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useInsetHeaderMagnet = void 0;

var _useScreen = require("./useScreen");

var _Root = require("../Root/Root");

var _useScrollY = require("./useScrollY");

var _pickNearestBreakpoint = require("../utils/pickNearestBreakpoint");

var _HeadersCompiler = require("../MultiHeaders/HeadersCompiler");

// todo write test
var useInsetHeaderMagnet = function useInsetHeaderMagnet(disabled) {
  // this hook will run only for <InsetSidebar position="fixed" />
  var _useLayoutCtx = (0, _Root.useLayoutCtx)(),
      builder = _useLayoutCtx.builder;

  var screen = (0, _useScreen.useScreen)(); // dont't calculate scrollY if not magnet for performance

  var scrollY = (0, _useScrollY.useScrollY)(disabled);
  if (disabled) return {
    marginTop: ""
  };
  var offset = (0, _HeadersCompiler.HeadersCompiler)([builder.header, builder.topHeader, builder.subheader]).getAllHeight().diffHeight;
  var maxOffset = offset && screen ? (0, _pickNearestBreakpoint.pickNearestBreakpoint)(offset, screen) : 0;
  return {
    marginTop: "max(-".concat(scrollY !== null && scrollY !== void 0 ? scrollY : 0, "px, calc(-1 * ").concat(maxOffset, "))")
  }; // inline style
};

exports.useInsetHeaderMagnet = useInsetHeaderMagnet;