"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useScrollY = void 0;

var _react = require("react");

var _utils = require("@mui/material/utils");

var _WindowContext = require("../WindowContext");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function getScrollY(obj) {
  return _typeof(obj) === "object" ? obj.scrollY : undefined;
}

var useScrollY = function useScrollY(disabled) {
  var _useWindowCtx = (0, _WindowContext.useWindowCtx)(),
      iWindow = _useWindowCtx.iWindow;

  var _useState = (0, _react.useState)(getScrollY(iWindow)),
      _useState2 = _slicedToArray(_useState, 2),
      scrollY = _useState2[0],
      setScrollY = _useState2[1];

  var debounceScrollListener = (0, _react.useRef)((0, _utils.debounce)(function () {
    setScrollY(getScrollY(iWindow));
  }, 300));
  (0, _react.useEffect)(function () {
    if (!disabled && iWindow !== undefined) {
      iWindow.addEventListener("scroll", debounceScrollListener.current);
      return function () {
        iWindow.removeEventListener("scroll", debounceScrollListener.current);
      };
    }
  }, [disabled]);
  return scrollY;
};

exports.useScrollY = useScrollY;