"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.combineBreakpoints = exports.sortBreakpoints = void 0;

var _muiBreakpoints = require("./muiBreakpoints");

var sortBreakpoints = function sortBreakpoints(breakpoints) {
  return breakpoints.sort(function (a, b) {
    return _muiBreakpoints.BREAKPOINT_KEYS.indexOf(a) - _muiBreakpoints.BREAKPOINT_KEYS.indexOf(b);
  });
};

exports.sortBreakpoints = sortBreakpoints;

var combineBreakpoints = function combineBreakpoints() {
  var result = [];

  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  args.forEach(function (item) {
    var breakpoints = Array.isArray(item) ? item : Object.keys(item);
    breakpoints.forEach(function (k) {
      if (!result.includes(k)) {
        result.push(k);
      }
    });
  });
  return sortBreakpoints(result);
};

exports.combineBreakpoints = combineBreakpoints;